0001                  ORG 0CA00H
0002 *
0003 *#*  MEMORY BLOCK CLEAR *#*
0004 *          by Ralph Hopkins   Eagan,Minn.  03-25-79
0005 *
0006 *
0007 * ROUTINE to clear memory
0008 *
0009 * ::: Works like the SOL "EN" and "DU" commands.
0010 *     ...(1) Enter "CL" as a custom command with the
0011 *            the start address of the program.
0012 *     ...(2) Enter "CL xxxx yyyy"
0013 *               -=- xxxx = start address of clear
0014 *               -=- yyyy = end address of clear
0015 *
0016 *======================================================*
0017 *
0018 CLEAR   CALL SCONV  ; Scan to 1st address & convert it
0019         PUSH H
0020         CALL PSCAN  ; Get any 2nd address
0021         POP  D
0022         SHLD LAST   ; Save "LAST" address
0023         XCHG        ; "HL" has START, "DE" has END
0024         SHLD START  ; Save START address
0025         SHLD NEXT   ; Start of clear buffer
0026         XRA  A      ; Initialize...
0027         OUT 0FEH    ; VDM
0028         OUT 0C8H    ; SOL
0029         CALL PERSE  ; Clear screen
0030 *
0031 ; (Output messages)
0032 *
0033         LXI  H,MSG1  ; Header message
0034         CALL MESS
0035         CALL CRLF
0036 *
0037         LXI  H,MSG2  ; 2nd message (INSTRUCTIONS)
0038         CALL MESS
0039        CALL CRLF
0040 ; -=-
0041 DOIT   LHLD LAST
0042        XCHG
0043        LHLD NEXT
0044 DOIT1  INX  H      ; Increment NEXT address to clear
0045        SHLD NEXT   ; put it back
0046        MOV  A,L    ; *#* COMPARE "DE" & "HL"
0047        SUB  E       ;  for end of clear.
0048        MOV  A,H
0049        SBB  D
0050        JNC  WRAP   ; All done.  Wrap it up.
0051        LXI  H,BYTE ; Get BYTE to write
0052        MOV  A,M
0053        LHLD NEXT
0054        MOV  M,A
0055        JMP  DOIT
0056 ; -=-
0057 WRAP   LXI  H,MSG0  ; END Message
0058        CALL MESS
0059        JMP  SOLOS
0060 *
0061 *
0062 ; :::: SUBROUTINE MESSAGE ::::
0063 *
0064 *** Message output routine:
0065 ;     "HL" must have the message address.
0066 ;     "00" byte is used to end a message.
0067 *
0068 *................................................*
0069 *
0070 MESS  MOV  A,M   ; Get a character
0071       CPI  0     ; "00" byte ?
0072       RZ         ; ... Yes, your done.
0073       CALL OUTH  ; ... No, output it.
0074       INX  H     ; Do more.
0075       JMP  MESS
0076 *
0077 *
0078 *===================================================*
0079 *
0080 ; -=- ;    EQUATES
0081 *
0082 SOLOS  EQU 0C004H
0083 SOUT   EQU 0C019H
0084 PERSE  EQU 0C0D5H
0085 CRLF   EQU 0C2F9H
0086 PSCAN  EQU 0C310H
0087 SCONV  EQU 0C33AH
0088 OUTH   EQU 0C41FH
0089 *
0090 MSG0   DB 'End of '
0091 MSG1   DB '*#* Memory block clear *#*'
0092        DB  0
0093 MSG2   DB 'ENTER byte pattern into address CAB0 : '
0094        DB  0
0095 *
0096 START  DW 0
0097 NEXT   DW 0
0098 LAST   DW 0
0099        DS 3
0100 BYTE   DB 0
0101 END    END
