0001 *   ALS8 disassembler....Don Van Dyke...Dr. Dobbs J., vol.3
0002 *
0016 * Input routines to process addresses before disassembly
0017 *
0018 *
0019         LXI  6,0D700H-1
0020         LXI  H,0CD00H
0021         SHLD INSLOC   * instruction loc.
0022         LXI  H,BUFF   * Buffer loc.
0023         SHLD BUFLOC   * Save it
0024         XRA  A
0025         OUT  0FEH
0026         OUT  0C8H
0027         CALL BLANK
0028         LXI  B,40H
0029         LXI  D,INST
0030         LHLD INSLOC
0031         CALL MESS
0032         LHLD INSLOC
0033         DAD  B
0034         DAD  B
0035         SHLD INSLOC
0036         INX  D
0037 MSD     MOV  A,H
0038         CPI  0CFH
0039         JZ   FSTPSS
0040         CALL MESS
0041         INX  D
0042         LHLD INSLOC
0043         DAD  B
0044         SHLD INSLOC
0045 CIN     CALL INPT
0046         CPI  0DH
0047         JNZ  CIN
0048         MVI  M,' '
0049         CALL PROCESS
0050         LHLD INSLOC
0051         DAD  B
0052         SHLD INSLOC
0053         JMP  MSD
0054 *
0055 * Routine to change 4 digit ascii to binary
0056 *
0057 PROCESS  PUSH D
0058          PUSH B
0059          LHLD BUFLOC
0060          XCHG
0061          LHLD INSLOC
0062          INX  H
0063          INX  H
0064          CALL ASC
0065          STAX D
0066          INX  D
0067          DCX  H
0068          DCX  H
0069          DCX  H
0070          CALL ASC
0071          STAX D
0072          INX  D
0073          XCHG
0074          SHLD  BUFLOC
0075          POP  B
0076          POP  D
0077          RET
0078 *
0079 ASC     CALL AGET  * Strip ascii bias
0080         RLC
0081         RLC
0082         RLC
0083         RLC
0084         MOV  B,A
0085         INX  H
0086         CALL AGET
0087         ADD  B
0088         RET
0089 AGET    MOV  A,M   * Get the char.
0090         SUI  30H
0091         CPI  0AH
0092         RC
0093         SUI  7
0094         RET
0095 *
0096 * ROUTINE TO CLEAR THE SCREEN
0097 *
0098 BLANK   LXI  H,0CC00H  * Begin'g of screen
0099 BLK     MVI  M,' '
0100        INX  H
0101        MOV  A,H
0102        CPI  0D0H
0103        JNZ  BLK
0104        RET
0105 *
0106 * This is the INPUT routine, complete w/cursor
0107 * receiving input from the current solos pseudo
0108 * input port.
0109 *
0110 INPT   MVI  M,0A0H
0111 IN     CALL 0C01FH
0112        JZ   IN
0113        CPI  0DH     * <CR> ?
0114        RZ
0115        CPI  7FH     * DELETE?
0116        JNZ  ARD
0117        MVI  M,' '
0118        DCX  H
0119        JMP  CURS
0120 ARD    MOV  M,A   * DISP. CHAR.
0121        INX  H
0122 CURS   MVI  M,0A0H
0123        RET
0124 *
0125 * This routine displays a message at 'HL'.
0126 * The message is pointed to by 'DE'.
0127 *
0128 MESS    LDAX  D   * Get char.
0129         CPI   0
0130         RZ
0131         MOV   M,A
0132         INX   D
0133         INX   H
0134         JMP   MESS
0135 MOV     EQU   40H
0136 *
0137 *     <<<<   FIRST PASS   >>>>
0138 *
0139 * This pass finds all jumps and calls and places the
0140 * address in the ALS8 symbol table area.
0141 *
0142 FSTPSS   LXI  H,0D700H
0143          SHLD STABLOC   * Save position
0144          LXI  B,0D700H  * Start of symbol table
0145          LHLD BGNLOC
0146          XCHG
0147          LHLD END       * END of code
0148 AGNI     CALL ADCMP
0149          JZ   DOONE
0150          JC   DOONE
0151          LDAX D
0152          CPI  0D3H   * OUT?
0153          JZ   BT2
0154          CPI  0DBH   * IN?
0155          JZ   BT2
0156          CPI  0EBH   * XCHG?
0157          JZ   INHH
0158          CPI  0E3H   * XTHL?
0159          JZ   INHH
0160          CPI  2AH    * LHLD?
0161          JZ   FIND
0162          CPI  22H    * SHLD?
0163          JZ   FIND
0164          CPI  3AH    * LDA?
0165          JZ   FIND
0166          CPI  32H    * STA?
0167          JZ   FIND
0168          ANI  0CFH
0169          CPI  0CDH    * CALL?
0170          JZ   FIND
0171          CPI  1       * LXI?
0172          JZ   FIND
0173          ANI  0C7H
0174          CPI  0C2H
0175          JZ   FIND
0176          CPI  0C4H    * CALL?
0177          JZ   FIND
0178          CPI  0C3H    * JUMP?
0179          JZ   FIND
0180          CPI  6       * Done with 3 byte op's; now, 2 byte
0181          JZ   BT2
0182          CPI  0C6H    * Acc Immediates?
0183          JZ   BT2
0184 INHH     INX  D       * Coding for 1 byte op codes.
0185          JMP  AGNI    * Get next op code
0186 *
0187 BT2      INX  D       * Op was 2 bytes
0188          INX  D
0189          JMP  AGNI
0190 *
0191 * This routine places label address in ALS8 symb table
0193 *
0194 FIND     INX  D
0195          LDAX D
0196          STAX B
0197          INX  D
0198          INX  B
0199          LDAX D   * GET 2nd byte
0200          STAX B
0201          INX  D   * Setup 4 nxt address
0202          INX  B
0203          LHLD STABLOC
0204          INX  H
0205          INX  H
0206          SHLD STABLOC
0207          LHLD END
0208          JMP  AGNI  * End of obj. code?
0209 *
0210 * ROUTINE to compare 2 addresses
0211 *
0212 ADCMP    MOV  A,L
0213          CMP  E
0214          JZ   FUR2
0215          RNC
0216 FUR2     MOV  A,H
0217          CMP  D
0218          RET
0219 *
0220 *     <<<<   SECOND PASS   >>>>
0221 *
0222 * This pass disassembles into the actual mnemonics,
0223 *   placing line numbers and labels.
0224 *
0225 DOONE    LHLD PLO     * Get starting positioE
0226          SHLD PLOC    * Save it
0227 START    LHLD BGNLOC  * Get starting address
0228          SHLD POSLOC
0229 NEWOP    LHLD POSLOC  * Get position
0230          XCHG
0231          LHLD END     * Get END address
0232          CALL ADCMP   * Done yet?
0233          JZ   THEND   * ...yes
0234          JNC  ANMM    * ...no
0235 THEND    LHLD PLOC
0236          MVI  M,01    * Place EOF marker as LAST byte !
0237          INX  H
0238          MVI  M,' '   * AND a blank
0239          JMP  FILES   * Go set line lengths
0240 ANMM     LHLD POSLOC
0241          MOV  A,M
0242          STA  OPLOC
0243          JMP  LOKUP   * Lookup basic mnemonic
0244 NEXBT    LDAX D
0245          CPI  8       * These are dividers 4 the mnemonic table
0246          RZ
0247          CPI  10H
0248          RZ
0249          CPI  18H
0250          RZ
0251          CPI  20H
0252          RZ
0253          CPI  28H
0254          RZ
0255          CPI  0
0256          INX  D
0257          LDAX D
0258          JNZ  NEXBT
0259          RET
0260 ADC22    MOV  A,L
0261          CMP  E
0262          RNZ
0263          MOV  A,H
0264          CMP  D
0265          RET
0266 *
0267 * ROUTINE to look up the mnemonic
0268 *
0269 LOKUP    LHLD POSLOC
0270          XRA  A
0271          STA  FLAG
0272          LXI  B,0D700H  * Start of symbol
0273 LABL     PUSH H
0274          LHLD STABLOC   * Get location in symbol table
0275          MOV  D,B
0276          MOV  E,C
0277          CALL ADC22
0278          POP  H
0279          JZ   NXT
0280          LDAX B
0281          MOV  E,A
0282          INX  B
0283          LDAX B
0284          MOV  D,A
0285          CALL ADC22  * Addresses equal?
0286          JZ   MATCH  * Address is in the table
0287          INX  B
0288          JMP  LABL
0289 MATCH    MVI  A,01   * Set "label needed" flag
0290          STA  FLAG
0291 NXT      LXI  D,TAB3H  * Look 4 illegal OP code
0292          LDA  OPLOC
0293          MOV  B,A
0294 LJK      LDAX D
0295          INX  D
0296          CPI  0     * END of table?
0297          JZ   ENOD
0298          CMP  B
0299          JNZ  LJK
0300          CALL LINE   * Illegal OP
0301          MVI  M,'D'  * Put a "DB" OP in the file
0302          INX  H
0303          MVI  M,'B'
0304          INX  H
0305          MVI  A,01   * Tell the program OP is 1 byte
0306          STA  CLOCLOC
0307          STA  LOCLOC
0308          JMP  SPACE  * Finish the line
0309 ENOD     LDA  OPLOC  * Get the OP
0310          CPI  01
0311          JNZ  LKOO
0312          MOV  B,A
0313          LXI  D,OPTB  * Start of OP code table
0314          JMP  RPOFF
0315 LKOO     MOV  B,A     * Save a copy
0316          LXI  D,OPTAB
0317 LOOK1    CALL NEXBT   * Get DATA
0318          CMP  B
0319          JZ   ADDIT   * Add it to the file
0320          CPI  08H     * END-of-section?
0321          JNZ  LOOK1
0322          INX  D
0323 RPOFF    MOV  A,B
0324          ANI  0CFH
0325          MOV  B,A
0326 LOOK2    CALL NEXBT
0327          CMP  B
0328          JZ   RPS
0329          CPI  10H
0330          JNZ  LOOK2
0331          INX  D
0332          MOV  A,B
0333          ANI  0C7H
0334          MOV  B,A
0335 LOOK3    CALL NEXBT
0336          CMP  B
0337          JZ   DEST
0338          CPI  18H
0339          JNZ  LOOK3
0340          INX  D
0341          LDA  OPLOC  * Get the COPY
0342          ANI  0F8H   * sources
0343          MOV  B,A
0344 LOOK4    CALL NEXBT
0345          CMP  B
0346          JZ   SRCS
0347          CPI  20H
0348          JNZ  LOOK4
0349          MOV  A,B
0350          ANI  0C0H
0351          CPI  40H
0352          JNZ  ERROR  * OP code not in table
0353 MOVE     XCHG
0354          SHLD MNLOC  * Mnemonic location
0355          MVI  A,5    * DEST, source
0356          STA  TYPE
0357          LDA  OPLOC
0358          ANI  7
0359          CALL ASCII
0360          STA  SRCLOC  * Store ASCII for source
0361          LDA  OPLOC
0362          ANI  38H
0363          RAR
0364          RAR
0365          RAR
0366          CALL ASCII
0367          STA  DSTLOC  * Store dest.
0368          JMP  PUT     * Put it in the file
0369 SRCS     XCHG SOURCES
0370          SHLD MNLOC
0371          MVI  A,3
0372          STA  TYPE
0373          LDA  OPLOC
0374          ANI  7
0375          CALL ASCII
0376          STA  SRCLOC
0377          JMP  PUT
0378 DEST     XCHG         * Destinations only
0379          SHLD MNLOC
0380          MVI  A,2
0381          STA  TYPE
0382          LDA  OPLOC
0383          ANI  38H
0384          RAR
0385          RAR
0386          RAR
0387          CALL ASCII
0388          STA  DSTLOC
0389          JMP  PUT
0390 RPS      XCHG         * Register pairs
0391          SHLD MNLOC
0392          MVI  A,4
0393          STA TYPE
0394          LDA OPLOC
0395          ANI  30H
0396          RAR
0397          RAR
0398          RAR
0399          RAR
0400          CPI  0
0401          JNZ  LP1
0402          MVI  B,42H
0403          JMP  ARND
0404 LP1      CPI  01
0405          JNZ  LP2
0406          MVI  B,44H
0407          JMP  ARND
0408 LP2      CPI  2
0409          JNZ  LP3
0410          MVI  B,48H
0411          JMP  ARND
0412 LP3      CPI  3
0413          JNZ  ERROR
0414          MVI  B,'6'    * SP, PSW
0415          JMP  PUT
0416 ADDIT    MVI  A,1      * Simple
0417          STA  TYPE
0418          XCHG
0419          SHLD MNLOC  * Save location of Mnemonic
0420 PUT      CALL LINE   * Add line numbers
0421 ARND     EQU  PUT
0422          LHLD  MNLOC
0423          INX  H
0424          MOV  A,M   * Number of bytes
0425          STA  LOCLOC
0426          INX  H
0427          XCHG
0428          LHLD PLOC  * Get position in file
0429          LDA  FLAG
0430          CPI  0     * Need label
0431          JZ   NCHR  * ... no
0432          PUSH B     * ... yes
0433          PUSH D
0434          DCX  H
0435          CALL LABLER  * Put on the label
0436          INX  H
0437          POP  D
0438          POP  B
0439 NCHR     LDAX D
0440          CPI  0
0441          JZ   ENDOP  * End of OP codes
0442          MOV  M,A
0443          INX  D
0444          INX  H
0445          JMP  NCHR
0446 ENDOP    LDA  TYPE
0447 * 1=simple
0448 * 2=dest. only
0449 * 3=source only
0450 * 4=REG. pair
0451 * 5=Dest. source
0452         DCR  A
0453         JZ   CR  * Simple
0454         DCR  A
0455         JZ   DO  * Dest. only
0456         DCR  A
0457         JZ   SO  * Source only
0458         DCR  A
0459         JZ   RP  * Reg. pair
0460         DCR  A
0461         JNZ  ERROR  * Nothing?
0462         MVI  M,' '
0463         INX  H
0464         LDA  DSTLOC  * Get the destination
0465         MOV  M,A
0466         INX  H
0467         MVI  M,','
0468         INX  H
0469         LDA  SRCLOC  * Get the source
0470         MOV  M,A
0471         INX  H
0472         JMP  CR
0473 RP      MVI  M,' '   * Reg. pair
0474         INX  H
0475         MOV  M,B
0476         INX  H
0477         JMP  CR
0478 DO      LDA  OPLOC   * Dest. only
0479         ANI  0C7H
0480         CPI  0C2H
0481         JZ   DOO
0482         CPI  0C4H
0483         JZ   DOO
0484         CPI  0C0H
0485         JZ   DOO
0486         MVI  M,' '
0487         INX  H
0488         LDA  DSTLOC
0489         MOV  M,A
0490         INX  H
0491         JMP  CR
0492 DOO     LXI  D,TAB2-2  * Get the condition
0493         LDA  OPLOC
0494         ANI  38H
0495         RAR
0496         RAR
0497         RAR
0498         INR  A
0499 LPDCR   DCR  A  * Look it up in the table
0500         INX  D
0501         INX  D
0502         JNZ  LPDCR
0503         LDAX D
0504         MOV  M,A
0505         INX  H
0506         INX  D
0507         LDAX D
0508         CPI  0  * END of table?
0509         JZ   CR
0510         MOV  M,A
0511         INX  H
0512         JMP  CR
0513 *
0514 * TABLE of conditions for CALL, RET, JMP
0515 *
0516 TAB2    ASC  'NZ'
0517         ASC 'Z'
0518         DB   0
0519         ASC  'NC'
0520         ASC  'C'
0521         DB   0
0522         ASC  'PO'
0523         ASC  'PE'
0524         ASC 'P'
0525         DB 0
0526         ASC 'M'
0527         DB 0
0528 SO      MVI  M,' '  * Source only
0529         INX  H
0530         LDA  SRCLOC
0531         MOV  M,A
0532         INX  H
0533 *
0534 * This ROUTINE places information after the Mnemonic
0535 *
0536 CR      EQU  $
0537         LDA  LOCLOC  * Get # of bytes
0538         DCR  A
0539         JZ   LPLPLP  * 1 byte
0540         STA  CLOCLOC  * Put it back (-1)
0541         MVI  M,','
0542         LDA  OPLOC
0543         ANI  0CFH
0544         CPI  1
0545         JZ   COMMA  * Need a comma
0546         ANI  0C7H
0547         CPI  6
0548         JZ   COMMA
0549 SPACE   MVI  M,' '  * Need a space
0550 COMMA   INX  H
0551         MVI  M,'0'  * 0 for 2nd and/or 3rd byte
0552         INX  H
0553         PUSH H
0554         LHLD POSLOC  * Get the object position
0555         LDA  LOCLOC  * # of bytes
0556         DCR  A
0557         JZ   BYINX   * Two bytes
0558         INX  H
0559 BYINX   MOV  A,M     * Put on the DATA
0560         CALL ASSGET  * Get the ASCII
0561         MOV  D,B
0562         MOV  E,C
0563         INX  H
0564         MOV  A,M     * Next char.
0565         CALL ASSGET  * Get the ASCII
0566         POP  H
0567         LDA  CLOCLOC
0568         DCR  A
0569         JZ   BEYOND  * Done?
0570         PUSH D
0571         CALL CHEKR   * Is address inside program?
0572         POP  D
0573         MOV  M,B
0574         INX  H
0575         MOV  M,C
0576         INX  H
0577 BEYOND  MOV  M,D     * Put it in the file
0578         INX  H
0579         MOV  M,E
0580         INX  H
0581         MVI  M,'H'   * H for HEX
0582         INX  H
0583 LPLPLP  MVI  M,' '   * Space out to comment field
0584         INX  H
0585         MVI  M,' '   * Another BLANK
0586         INX  H
0587         XCHG
0588         LHLD POSLOC  * Where are we?
0589         XCHG
0590         LDA  LOCLOC  * Get # of bytes
0591         MOV  B,A
0592         DCR  A
0593         JNZ  LP5H     * > 1 byte OP
0594         LDA  TYPE
0595         DCR  A
0596         JNZ  LP5H     * Put in a '.' to make ALS8 happy
0597         DCX  H
0598         MVI  M,'.'
0599         INX  H
0600        MVI  M,' '
0601        INX  H
0602        MVI  M,' '
0603        INX  H
0604        LDAX D
0605        CPI  0E9H
0606        JZ   PHL1
0607 LP5H   LDAX D
0608        CPI  07FH
0609        JNC  NEXTS
0610        CPI  020H
0611        JC   NEXTS
0612        MOV  M,A
0613        JMP  BHU
0614 PHL1   PUSH D
0615        LXI  D,PCHL
0616        CALL MESS
0617        POP  D
0618 NEXTS  MVI  M,' '
0619 BHU    INX  H
0620        INX  D
0621        DCR  B
0622        JNZ  LP5H  * Done?
0623        MVI  M,0DH   * Yes, put in <CR>
0624        INX  H
0625        SHLD PLOC
0626        XCHG
0627        SHLD POSLOC  * Replace pointers
0628        XCHG
0629        JMP  NEWOP   * Get the next OP code
0630 *
0631 * ROUTINE to convert "A" to 2 byte display number
0632 *
0633 ASSGET  MOV  B,A
0634         ANI  0FH
0635         ADI  30H  * Add AC_SCII bias
0636         CPI  3AH
0637         JC   LPPL
0638         ADI  7
0639 LPPL    MOV  C,A  * Do 2nd half
0640         MOV  A,B
0641         ANI  0F0H
0642         RAR
0643         RAR
0644         RAR
0645         RAR
0646         ADI  30H  * Add ASCII bias
0647         CPI  03AH
0648         JC   PLLP
0649         ADI  7
0650 PLLP    MOV  B,A
0651         RET
0652 ASCII   INR  A   * Get the register
0653         LXI  D,TAB
0654 LP      DCR  A
0655         JZ   LOOK
0656         INX  D
0657         JMP  LP
0658 LOOK    LDAX D
0659         RET
0660 *
0661 * ROUTINE to place line numbers in the file
0662 *
0663 LINE    LHLD PLOC  * Place in file
0664         MVI  M,' '   * A BLANK
0665         INX  H
0666         MVI  A,4
0667 LPP     MVI  M,'0'
0668         DCR  A
0669         INX  H
0670         JNZ  LPP  * 4 zeros
0671         MVI  M,' '
0672         INX  H
0673         MVI  M,' '
0674         INX  H     * 2 spaces
0675         SHLD PLOC
0676         RET
0677 *
0678 * ROUTINE to place labels in the file
0679 *
0680 LABLER  MVI  M,'L'  * Put in the L
0681         INX  H
0682         XCHG
0683         LHLD POSLOC
0684         XCHG
0685         MOV  A,D
0686         CALL ASSGET  * Convert the number
0687         MOV  M,B
0688         INX  H
0689         MOV  M,C
0690         MOV  A,E
0691         CALL ASSGET
0692         INX  H
0693         MOV  M,B
0694         INX  H
0695         MOV  M,C
0696         INX  H
0697         MVI  M,'H'  * Put an H on the END
0698         INX  H
0699         MVI  M,' '
0700         RET
0701 *
0702 * ROUTINE to see if address is in object
0703 *
0704 CHEKR    PUSH H
0705          LHLD POSLOC
0706          INX  H
0707          MOV  E,M
0708          INX H
0709          MOV  D,M
0710          LHLD END   * Get address of END
0711          MOV  A,H
0712          CMP  D
0713          JZ   FURTH  * Check further
0714          JNC  LESS   * inside
0715          JMP  OUT    * outside program
0716 FURTH    MOV  A,L
0717          CMP  E
0718          JZ   OUT
0719          JC   OUT
0720 LESS     LHLD BGNLOC  * See if its < than beginning
0721          MOV  A,H
0722          CMP  D
0723          JZ   FUR1
0724          JNC  OUT
0725 FUR1     MOV  A,L     * Check further
0726          CMP  E
0727          JZ   LTTN
0728          JC   LTTN
0729 OUT      POP  H     * Outside, so no local label
0730          RET
0731 LTTN     POP  H     * Finally found one inside
0732          DCX  H
0733          MVI  M,'L'  * Put on the "L" for local
0734          INX  H
0735          RET
0736 *
0737 * This ROUTINE sets the line length pointer for ALS-8
0738 *
0739 FILES   MVI  E,0
0740 FLIES   LHLD BUFF+4  * Find beginning of FILE
0741         DCX  H
0742         MOV  B,H     * Put "HL" in "BC"
0743         MOV  C,L
0744         JMP  FILIS   * The setup
0745 FILOS   MOV  B,H
0746         MOV  C,L
0747         INX  B
0748         INX  H
0749         INX  H
0750 FILIS   MVI  D,1    * 2 passes
0751 FILIES  MOV  A,M
0752         CPI  0DH    * End of line?
0753         JZ   FIL2
0754         DCX  H
0755         MOV  A,M
0756         CPI  1      * EOF ?
0757         JZ   FIL3   * ...yes
0758         INX  H
0759         MOV  A,M
0760         CPI  20H
0761         JNC  FIL1   * < 20H ?
0762         MVI  M,' '  * ...yes, put a SPACE
0763 FIL1    INR  D
0764         INX  H
0765         JMP  FILIES
0766 FIL2    INR  D
0767         MOV  A,D
0768         STAX B    * Put the length
0769         JMP  FILOS
0770 FIL3    XRA  A
0771         CMP  E
0772         JNZ  ALS8  * DONE !!!
0773         INR  E
0774         JMP  FLIES
0775 *
0776 * <<<<   THIS IS THE TABLE AREA   >>>>
0777 *
