0001                  ORG 0CA00H
0003 * LOCATE.SOL
0005 *#*  8080 OBJECT CODE SEARCH *#*
0007 *          by Ralph Hopkins   Eagan,Minn.  03-25-79
0009 *
0011 *
0013 * ROUTINE to compare memory for up to 12 characters
0015 * ...then print out the address with the bytes(s)
0017 *
0019 * ::: Works like the SOL "EN" and "DU" commands.
0021 *     ...(1) Enter "LO" as a custom command with the
0023 *            the start address of the program.
0025 *     ...(2) Enter "LO xxxx yyyy"
0027 *               -=- xxxx = start address of search
0029 *               -=- yyyy = end address of search
0031 *
0033 *======================================================*
0035 *
0037 LOCATE  CALL SCONV  * Scan to 1st address & convert it
0039         PUSH H
0041         CALL PSCAN  * Get any 2nd address
0043         POP  D
0045         SHLD LAST   * Save "LAST" address
0047         XCHG        * "HL" has START, "DE" has END
0049         SHLD START  * Save START address
0051         SHLD NEXT   * Start of search buffer
0053         LXI  H,BUFF * Reset start-of BUFF loc.
0055         SHLD BOOF
0057 *
0059 *       DCX  H       * Clear COUNT
0061 *       MVI  B,012H  * Byte count
0063 *      CALL CLEAR
0065 *
0067         XRA  A      * Initialize...
0069         OUT 0FEH    * VDM
0071         OUT 0C8H    * SOL
0073         CALL PERSE  * Clear screen
0075 *
0077 * (Output messages)
0079 *
0081         LXI  H,MSG1  * Header message
0083         CALL MESS
0085         CALL CRLF
0087 *
0089         LXI  H,MSG2  * 2nd message (INSTRUCTIONS)
0091         CALL MESS
0093 * -=-
0095 DOIT   CALL COMP   * Do a block compare
0097        LHLD LAST
0099        XCHG
0101        LHLD NEXT
0103        CPI 0       * Accum returned a match?
0105        JZ  RPORT   * ...yes, get the Report
0107 DOIT1  INX  H      * Increment NEXT address to search
0109        SHLD NEXT   * put it back
0111        MOV  A,L    *#* COMPARE "DE" & "HL"
0113        SUB  E       *  for end of search.
0115        MOV  A,H
0117        SBB  D
0119        JNC  WRAP   * All done.  Wrap it up.
0121        JMP  DOIT
0123 * -=-
0125 RPORT  CALL CRLF
0127        LHLD NEXT  * Get NEXT address
0129        DCX  H
0131        CALL ADOUT * Output the bytes
0133        CALL BOUT  * ...And a space.
0135        LHLD COUNT * Get byte count
0137        INX  H     * Output byte COUNT + 2 more !!!!
0139        INX  H
0141        SHLD ZERO
0143        LHLD NEXT
0145        SHLD BOOF
0147 RPOR1  MOV  A,M   * Get a byte
0149        CALL HEOUT * Output 1 byte
0151        CALL BOUT  * ...plus a space.
0153        LXI  H,ZERO  * Output byte count address
0155        DCR  M
0157        LHLD NEXT  * Get NEXT address to search
0159        JZ   DOIT1 * Done outputing
0161        LHLD BOOF  * Advance output pointer
0163        INX  H
0165        SHLD BOOF
0167        JMP  RPOR1
0169 * -=-
0171 WRAP   LXI  H,MSG0  * END Message
0173        CALL MESS
0175        JMP  SOLOS
0177 *
0179 *
0181 * ::: SUBROUTINE COMPARE :::
0183 *
0185 *** Compares the contents of 2 equal length memory blocks
0187 *   ...On return, if Acc=0 then match is good
0189 *        COUNT = byte compare count
0191 *        BUFF  = start address of compare buffer
0193 *        NEXT  = start of memory compare area
0195 *
0197 *........................................................*
0199 *
0201 COMP   LXI  H,COUNT  * Get count of how many bytes
0203        MOV  C,M      * Save compare count in "C"
0205        LHLD NEXT     * Get NEXT search address into "DE"
0207        XCHG
0209        LXI  H,BUFF   * Get BUFF (start) search address
0211 *
0213 COM1   MOV  B,M      * "BUFF" CHAR TO "B"
0215        XCHG
0217        MOV  A,M      * NEXT char. to Acc.
0219        SUB  B        * Subtract (NEXT) - (BUFF)
0221        RNZ           * Return with Acc.=0 !!! Match!
0223        RC            * Mismatch !
0225        DCR  C        * Decrement COUNT
0227        RZ            * Done comparing. Return with Acc.=0!
0229        INX  H        *#* Advance compare pointers
0231        INX  D         * ... to look for next char.
0233        XCHG           * ... to compare for.
0235        JMP  COM1
0237 *
0239 *
0241 * :::: SUBROUTINE MESSAGE ::::
0243 *
0245 *** Message output routine:
0247 *     "HL" must have the message address.
0249 *     "00" byte is used to end a message.
0251 *
0253 *................................................*
0255 *
0257 MESS  MOV  A,M   * Get a character
0261       CPI  0     * "00" byte ?
0263       RZ         * ... Yes, your done.
0265       CALL OUTH  * ... No, output it.
0267       INX  H     * Do more.
0269       JMP  MESS
0271 *
0273 *
0275 * :::: SUBROUTINE CLEAR ::::
0277 *
0279 *** Routine to clear up to 256 bytes of memory
0281 *        "HL" must have start address
0283 *        "B"  must have the byte count
0285 *
0287 *....................................................*
0289 *
0291 *CLEAR MVI  M,0  * Load memory with 0
0293 *      DCR  B    * Decrement the count.
0295 *      RZ        * Return when done.
0297 *      INX  H    * Continue
0299 *      JMP  CLEAR
0301 *
0303 *===================================================*
0305 *
0307 * -=- *    EQUATES
0309 *
0311 SOLOS  EQU 0C004H
0313 SOUT   EQU 0C019H
0315 PERSE  EQU 0C0D5H
0317 CLINE  EQU 0C0F4H
0319 CRLF   EQU 0C2F9H
0321 PSCAN  EQU 0C310H
0323 SCONV  EQU 0C33AH
0325 ADOUT  EQU 0C3E8H
0327 BOUT   EQU 0C406H
0329 HEOUT  EQU 0C40BH
0330 OUTH   EQU 0C41FH
0331 *
0333 MSG0   ASC 'End of '
0335 MSG1   ASC '*#* 8080 Object Code search *#*'
0337        DB  0
0339 MSG2   ASC 'ENTER byte count into address CB20 ... '
0341 MSG3   ASC 'CB21-CB2F = Search buffer'
0343        DB  0
0345 *
0347 ZERO   DB 0
0349 START  DW 0
0351 NEXT   DW 0
0353 LAST   DW 0
0355 BOOF   DW 0
0357 COUNT  DB 1
0359 BUFF   DB 0CDH
0361        DS 14
0363 ENDIT  END
