0001 *
0002 *
0003 *
0004 *======================================================*
0005 *                                                      *
0006 *       PROGRAM TO READ "BINARY" PAPER TAPE INTO A     *
0007 *   SOL-20 FROM AN 'OP80' PAPER TAPE READER.           *
0008 *       THE BLANK LEADER IS READ AS BINARY 00 AND WILL *
0009 *   DISPLAYED ON THE SCREEN AS A TRAIL OF PERIODS..... *
0010 *   THE FIRST NON-BLANK CHARACTER ON THE PAPER TAPE    *
0011 *   WILL THEN GO INTO ADDRESS 0000.  PART OF THE SOLOS *
0012 *   SYSTEM "FIRMWARE" IS USED TO DISPLAY THE TAPE CODE *
0013 *   SO THAT IT WILL LOOK VERY MUCH LIKE THE 'DUMP'     *
0014 *   ROUTINE ON THE SCREEN.                             *
0015 *       THIS WAS WRITTEN SPECIFICALLY TO LOAD A TAPE   *
0016 *   LABLED 'MICROCHESS' FROM MICRO-WARE LIMITED        *
0017 *           27 FIRSTBROOKE ROAD   TORONTO  ONTARIO     *
0018 *           CANADA         M4E  2L2                    *
0019 *                                                      *
0020 *** NOTE ***  ESCAPE KEY EXITS PROGRAM TO SOL MONITOR
0021 *             RETURN KEY RESTARTS THE PROGRAM
0022 *
0023 *=====================================================*
0024 ****************************
0025 **                        **
0026 **     E Q U A T E S      **
0027 **                        **
0028 ****************************
0029 *
0030 ADOUT  EQU 0C3E8H    * SUBROUTINE TO OUT "HL" CONTENTS
0031 BOUT   EQU 0C406H    * ...PART OF ADOUT
0032 CRLF   EQU 0C2F9H    * SUBROUTINE TO OUTPUT A "CR"
0033 HBOUT  EQU 0C3EDH    * ...PART OF ADOUT
0034 IPORT  EQU 0C806H    * SOLOS SYSTEM INPUT PORT ADDRS.
0035 SINP   EQU 0C01FH    * SYSTEM ENTRY POINT
0036 SOLOS  EQU 0C004H    * RETURN TO SYSTEM MONITOR
0037 SOUT   EQU 0C019H    * SUBROUTINE TO OUTPUT A CHAR. TO VDM
0038 SYSTP  EQU 0CBFFH    * SYSTEM STACK POINTER
0039 KSTAT  EQU  0C02EH   * SOLOS KEYBOARD INPUT DRIVER
0040 *
0041 *
0042 * = = = = = = = = = = = = = = = = = = = = = = = = = = *
0043 *
0100 START  XRA  A        * INTIALIZE ...
0101        OUT  0FEH     * ...SOL
0102        OUT  0C8H     * ...VDM
0103        LXI  H,FLAG
0104        MVI  A,00H
0105        MOV  M,A      * CLEAR 'FLAG' FOR 1ST BYTE ON TAPE
0106        LXI  H,SYSTP  * SET UP STACK
0107        SPHL
0108        MVI  A,010H
0109        OUT  0FAH
0110        CALL PTIN     * LOOK FOR A CHAR. OR AN ESCAPE KEY
0111 *
0120 LEADR  LXI  H,FLAG   * FIND 1ST NON-ZERO CHAR ?
0121        MOV  A,M
0122        CPI  00H
0123        JNZ  DISPL    * ...YES, START DISPLAYING CONTENTS
0124        LXI  H,SAVE
0125        MVI  A,00H
0126        CMP  M        * STILL ON BLANK LEADER ?
0127        JZ   DOTS     * ...YES, PRINT PERIODS
0128        MVI  A,02EH   * ...NO, SET "FLAG" WITH A PERIOD
0129        LXI  H,FLAG
0130        MOV  M,A
0131        JMP  DISPL
0132 *
0140 DOTS   MVI  B,02EH   * PUT PERIODS ON SCREEN
0141        CALL SOUT     * FOR BEGINNING OF LEADER
0142        CALL PTIN
0143        JMP LEADR
0150 DISPL  LHLD LOAD     * SET-UP "HL" FOR 1ST ADDRESS = 0000
0152        PUSH H
0153 PART2  CALL CRLF
0154        CALL ADOUT
0155        CALL BOUT
0156        MVI  C,16
0157 PART3  PUSH H
0158        MVI  A,00H
0159        CMP  L        * LOOKING FOR ADDRESS "0000"
0160        JNZ  PART4    * ...NO, PAST ADDRESS "0000"
0161        MVI  A,00H
0162        CMP  H
0163        JNZ  PART4    * ...NO
0164        LXI  H,SAVE   * ...YES, AT ADDRESS  0
0165        MOV  A,M      * RESTORE SAVED 1ST CHAR.
0166        JMP  PART5
0167 PART4  CALL PTIN     * GET A CHAR.
0168 PART5  POP  H
0169        PUSH B
0170        CALL HBOUT
0171        POP  B
0172        PUSH H
0173        LXI  H,SAVE
0174        MOV  A,M
0175        POP  H
0176 * REMOVE THIS NEXT LINE TO *NOT* ENTER THE DATA IN MEMORY
0177        MOV  M,A    *#*  ACTUALLY PUT CHAR. IN MEMORY
0178        INX  H
0179        DCR  C
0180        JNZ  PART3
0181        JMP  PART2
0182 *
0183 *
0200 PTIN   MVI  A,00H
0201        CALL KSTAT      * KEYBOARD CHAR. ?
0202        ANI  07FH       * STRIP PARITY
0203        CPI  01BH       * ESCAPE KEY ?
0204        JZ   SOLOS      * ...YES, RETURN TO SOLOS
0205        CPI  0DH        * CARRIAGE RETURN KEY ?
0206        JZ   START      * ...YES, RESTART PROGRAM
0210        IN   0FAH       * INPUT BINARY FROM OP80
0211        ANI  002H
0212        JNZ  PTIN
0213        MVI  A,00H
0214        OUT  0FAH       * TOGGLE ACK.
0215        MVI  A,00H
0216        OUT  0FAH
0217        IN   0FDH
0218        LXI  H,SAVE     * SAVE THE CHAR. FROM THE OP80
0219        MOV  M,A
0220        RET
0221 *
0222 *
0223 *
0230 SAVE   DB 00H
0231 FLAG   DB 00H
0232 LOAD   DW 0000H     * ADDRESS TAPE PROGRAM LOADS INTO
0233 *** NOTE ***   "LOAD" ADDRESS = "START" ADDRESS + 00A0
0235 END    END
