0010 START     ORG 0C900H
0020       MVI  A,80   * Changing the speed display from
0030       LXI  H,0C80BH   * '0' to '80'.
0040       MOV  M,A
0090        CALL CS     * Clear the screen
0100 RET   CALL KB     * The executive routine
0120       CPI  'C'    * Branches to CHASE on 'C'
0130       JZ   CH
0140       CPI  'H'    * HIC on 'H'
0150       JZ   HI
0160       CPI  'O'    * OPPS on 'O', and
0170       JZ   OP
0180       CPI  'L'    * LIFE on 'L'
0190       JZ   LI
0220       JMP  RET
1000 CH    CALL CS     * CHASE...clear screen
1005       CALL INIT   * Place the BUG
1010       LDA  FO+1   * ...at a random location
1020       MOV  M,A    * ...on the screen.
1030       XCHG
1040       CALL INIT   * Place the TURTLE
1050       LDA  FO     * ...at a random location
1060       MOV  M,A    * ...on the screen.
1070 C1    CALL DL     * Wait awhile
1075       CALL KB     * Get INPUT
1080       MVI  M,20H  * Put a space where you are,
1090       CALL MV     * Then move.
1100       LDA  FO+1   * If the BUG is there,
1110       CMP  M      * ...you've got him.
1120       JZ   HLT
1130       LDA  FO     * Place the TURTLE at new screen
1140       MOV  M,A    * ...location.
1150       XCHG
1170       CALL RND    * The BUG moves at random
1180       MVI  M,20H  * Put a space where it was,
1190       CALL MV     * ...then move.
1200       LDA  FO     * If the TURTLE is there,
1210       CMP  M      * ...the BUGS been had.
1220       JZ   HLT
1230       LDA  FO+1   * Place BUG at new screen
1240       MOV  M,A    * ...location.
1250       XCHG
1260       JMP  C1     * Do it all again.
1270 *
1280 *
1290 *
1300 HI    CALL CS     * HIC...clear the screen.
1305       LXI  H,0CE20H  * Place TURTLE at the
1310 H1    MVI  M,7       * ...center of the screen.
1315       CALL KB        * Should I return to the EXEC ?
1320       CALL DL        * Wait awhile.
1330       CALL RND       * Move the TURTLE at random
1340       MVI  M,2AH
1350       CALL MV        * ...leaving an * behind.
1370       JMP  H1        * Do it again.
1380 *
1390 *
1600 OP    CALL CS        * OPPS ...clear the screen.
1602       MVI  B,0       * Place HURTLE at the center
1605       LXI  H,0CE20H  * ...of the screen.
1610 O1    MOV  A,M       * If you have been
1620       CPI  2AH       * ...here before,
1630       JZ   HLT       * ...HALT.
1640       MVI  M,7       * Put the TURTLE on the screen
1650       CALL DL        * ....wait awhile.
1655 O2    CALL KB        * Get INPUT.
1658       JZ   O4        * If none, continue.
1660       MOV  B,A
1662 O4    MOV  A,B
1664       ANI  0FH       * If it is a '0', don't move.
1666       JZ   O2
1670       MVI M,2AH      * Place an * in the old location,
1680       CALL MV        * ...then move.
1690       JMP  O1        * Do it again.
1695 *
1700 HLT   MVI  M,4       * Place HEX 04 character on screen.
1710       JMP  RET       * Return to the EXEC.
1720 *
1730 *
1740 *
1800 MV    ANI  0FH       * MOVE...
1850       CPI 6
1860       JNZ  M1        * This routine uses the
1870       MVI  A,1       * CURSOR move routines
1880       JMP  M3        * in SOLOS (PUP, PLEFT, PDOWN,
1890 M1    CPI  1         * ...and PRIT) to move the
1900       JNZ  M2        * contents of the screen
1910       MVI  A,6       * Location pointed to
1920       JMP  M3        * ...by the address contained
1930 M2    CPI  7         * ...in the H & L registers.
1940       JNZ  M3
1950       MVI  A,0CH     *   The right 4 bits of the
2000 M3    MOV  C,A       * ACCUMULATOR are used to
2010       CALL SVDA      * ..determine the direction, or
2020       MVI  A,8       * ..combination of directions,
2030       ANA  C         * ..of the move.
2040       CNZ  0C104H    *   =----=----=----=----=
2050       MVI  A,1       *   : UP : LF : DN : RT :
2055       ANA  C         *   =----=----=----=----=
2060       CNZ  0C115H
2070       MVI  A,2       *   The ASCII code for all
2080       ANA  C         * of the digits except 6, 1,
2090       CNZ  0C0CBH    * and 7 allows a compass rose
2100       MVI  A,4       * that aggrees with the 10 key
2110       ANA  C         * numeric pad.
2120       CNZ  0C10BH    *   6, 1 and 7 are changed to agree.
2130       CALL 0C11CH
2140       RET
2150 *
2200 SVDA  MOV  A,L       *  This routine assumes that the
2210       ANI  3FH       * contents of the H,L reg. pair
2220       STA  0C808H    * ...is a screen address.
2230       DAD  H         *  It then stores the line number
2240       DAD  H         * ...in the DATA storage location
2250       MOV  A,H       * ...used by SOLOS called LINE.
2260       ANI  0FH       *   Similarily, the character
2270       ANI  0FH       * position is stored in  NCHAR
2280       STA  0C809H    * for use by PUP, PLEFT, PDOWN,
2290       RET            * ...and PRIT.
2295 *
3000 DL    PUSH 4         * DELAY...save address.
3005       LHLD 0C80AH    * Get data byte from SET command:
3010       INR  L         * SPEED  (done by SET S=80 command)
3020       XRA  A
3030 D1    DCX  H         * Use it for a counter.
3040       CMP  H
3050       JNZ  D1
3060       POP  H         * Restore address
3070       RET
3080 *
3090 *
3100 KB    CALL 0C02EH    * Get INPUT from keyboard.
3110       RZ             * If none, return.
3120       CPI  0DH       * If it is a CR, restore the stack
3130       RNZ            * ...and return to the EXEC.
3135       CPI  01BH      * If its an ESCAPE key
3136       RNZ            * ...restore stack & return to EXEC.
3140       POP  B
3150       JMP  RET
3160 *
3170 *
3180 *
3190 *
4000 LI    LXI  D,0      *  LIFE
4010 L1    MOV  L,E
4020       MOV  A,D       * D, E points to 1k of RAM
4030       ANI  3         * used as a scratch pad
4040       ORI  0CCH      * H, L points to the screen location
4050       MOV  H,A
4060       PUSH D         * Save the pointer
4070       MVI  C,0       * Initialize the counter
4080       DCX  H
4090       CALL CT
4100       DAD  D         * this location of the screen
4120       CALL CT        * in the following order:
4130       INX  H
4140       CALL CT        *   =----=----=----=
4150       INX  H         *   I    I    I    I
4160       CALL CT        *   I ^ -I-> -I--> I
4170       LXI  D,40H     *   I i  I    I  i I
4180       DAD  D         *   =----=----=----=
4190       CALL CT        *   I i  I    I  i I
4200       DAD  D         *   I  <-I--  I  V I
4210       CALL CT        *   I    I    I  i I
4220       DCX  H         *   =----=----=----=
4230       CALL CT        *   I    I    I  i I
4240       DCX  H         *   I  <-I- <-I- V I
4250       CALL CT        *   I    I    I    I
4251       INX  H         *   =----=----=----=
4252       LXI  D,0FFC0H
4253       DAD  D
4260       POP  D         * Restore  RAM  pointer.
4270       CALL RG        * Determine next generation
4280       INX  D         * ...for this location and
4290       MOV  A,D       * ...put it in the  RAM.
4300       ANI  4         * Do this to every screen location.
4310       JZ   L1
4320 *
4330 *
4340 *
5000 CP    LXI  H,0CC00H  * Copy the next generation
5010       LXI  D,0       * ...as stored in the 1k
5020 C0    LDAX D         * ...scratch pad  RAM
5030       MOV  M,A       * ...to the screen.
5040       INX  H
5050       INX  D
5060       MOV  A,H
5070       CPI  0D0H
5080       JNZ  C0
5090       CALL DL        * WAIT ... awhile.
5100       CALL KB        *   Should I return to the EXEC ?
5150       JMP  LI        * If not, do another generation.
5160 *
5170 *
7000 RG    MOV  A,C       * Follow the rules of LIFE
7010        CPI  2        * ...to determine the next
7020        JZ   R3       * ...for this location.
7030        JNC  R1
7040 R2     MVI  A,20H
7045        STAX D
7050        RET
7060 R1     CPI  3
7070        JNZ  R2
7080        MVI  A,'*'
7090        STAX D
7100        RET
7110 R3     MOV  A,M
7120        STAX D
7130        RET
7140 *
7150 *
7160 *
8000 CT    MOV  A,M      * COUNTER
8010       CPI  '*'
8020       RNZ           * If the neighbor is an *,
8030       INR  C
8040       RET           * ...count it.
8050 *
8060 *
8500 INIT  CALL RND      * INITIALIZE
8510       ANI  3FH
8515       ORI  0CCH     * Determine a random screen
8520       MOV  H,A      * Location, place the line number
8530       CALL RND      * in the data storage of SOLOS
8540       MOV  L,A      * called LINE and the position of
8550       RET           * the character in  NCHAR.
8560       STA  0C808H
8570       CALL RND
8580       ANI  0FH
8590       STA  0C809H
8594       CALL SVDA
8595       RET
8589 *
8600 RND   PUSH 4       * RANDOM NUMBER GENERATOR
8610       LXI  H,SH+3  * from Peoples Computer Company.
8620       MVI  B,8
8630       MOV  A,M     * For it to work properly,
8640 RTOP  RLC          * ...the 4 data locations
8641       RLC          * ...should not be zero.
8642       RLC
8650       XRA  M
8660       RAL
8670       DCR  L
8671       DCR  L
8672       DCR  L
8680       MOV  A,M
8690       RAL
8695       MOV  M,A
8700       INR  L
8710       MOV  A,M
8720       RAL
8730       MOV  M,A
8740       INR  L
8750       MOV  A,M
8760       RAL
8770       MOV  M,A
8780       INR  L
8790       MOV  A,M
8800       RAL
8810       MOV  M,A
8820       DCR  B
8830       JNZ  RTOP
8840       POP  H
8850       RET
8860 *
8870 *
8880 *
8890 *
8900 CS     CALL 0C0D5H  * In SOLOS, the routine  PERSE
8910        MVI  A,20H   * erases the screen but leaves a
8920        STA  0CC00H  * cursor in the corner.  Erase
8930        RET          * that too and return.
8940 *
8950 *
9000 FO     DB  7        * The TURTLE font.
9010        DB  0EH      * The BUG font.
9020 SH     DW  0123H    * Storage for RND
9030        DW  4567H
9040 ******
9050 END    END          ********************************
